<template>
  <div>
    <button
      v-if="isShowIcon"
      class="approaching-button"
      @click="onClickIcon"
    >
      <i class="icon refresh" />
    </button>
    <ApproachingModal
      ref="approachingModal"
      :order="suborderData"
    />
  </div>
</template>

<script>

  import ApproachingModal from '@/components/Order/modal/ApproachingModal'
  import STEPS from '@/constants/steps.js'
  import api from '@/api'

  export default {
    name: 'AccountOrderApproaching',
    props: {
      data: {
        type: Object,
        default: () => {}
      }
    },
    components: {
      ApproachingModal
    },
    data () {
      return {
        suborderData: {}
      }
    },
    computed: {
      isShowIcon () {
        return this.isFtl && this.isOneSuborder && this.isCorrectSuborder
      },
      isFtl () {
        return this.data.transportationWay === 'FTL'
      },
      notCancelledSuborders () {
        return this.data.suborders?.filter(item => item.status !== STEPS.CANCELLED)
      },
      isOneSuborder () {
        return this.notCancelledSuborders?.length === 1
      },
      isCorrectSuborder () {
        return this.notCancelledSuborders?.find(item => {
          return item.species === 'ORDER' && item.type === 'AUTO' && [STEPS.NEW, STEPS.SEARCH].includes(item.status)
        })
      }
    },
    methods: {
      async onClickIcon () {
        try {
          const suborder = this.notCancelledSuborders[0]
          this.suborderData = await api.orderProcess.getSubOrder({
            data: { uuid: suborder.uuid },
            orderUuid: this.data.uuid
          })
          this.$refs.approachingModal.open()
        } catch (e) {
          console.error(e)
        }
      }
    }
  }
</script>

<style scoped lang="scss">
  .approaching-button {
    width: 50px;
    margin: 0;
    padding: 5px;
    border: none;
    background-color: transparent;
    outline: none;
    cursor: pointer;
    text-align: center;
    .icon {
      font-size: 16px;
      color: $blue-700;
    }
    &:hover {
      opacity: 0.8;
    }
  }
</style>
